import { CanActivate, CanDeactivate, Router, UrlTree, ActivatedRouteSnapshot } from '@angular/router';
import { Observable } from 'rxjs';
import { CollectionState } from './collection.service';
import { CollectionService } from './collection.service';
import { QueryFn } from '@angular/fire/firestore';
export interface CollectionRouteData {
    queryFn: QueryFn;
    redirect: string;
}
export declare function CollectionGuardConfig(data: CollectionRouteData): (constructor: any) => void;
export declare class CollectionGuard<T> implements CanActivate, CanDeactivate<any> {
    protected service: CollectionService<CollectionState<T>>;
    protected router: Router;
    private subscription;
    protected readonly queryFn: QueryFn;
    protected readonly redirect: string;
    protected sync(next: ActivatedRouteSnapshot): Observable<any>;
    constructor(service: CollectionService<CollectionState<T>>, router: Router);
    canActivate(next: ActivatedRouteSnapshot): Promise<boolean | UrlTree>;
    canDeactivate(): boolean;
}
